
#include "Audio.hpp"

//These are mainly to set values of the different sound params
void setValues(ALfloat obj[],float x,float y,float z)
{
	obj[0] = x;
	obj[1] = y;
	obj[2] = z;
}

void setValues(ALfloat obj[],float x,float y,float z,float a,float b,float c)
{
	obj[0] = x;
	obj[1] = y;
	obj[2] = z;
	obj[3] = a;
	obj[4] = b;
	obj[5] = c;
}

Sound::Sound(char* soundfile)
{
	setValues(SourcePos,0.0f,0.0f,0.0f);
	setValues(SourceVel,0.0, 0.0, 0.0);
	setValues(ListenerPos,0.0, 0.0, 0.0);
	setValues(ListenerVel,0.0, 0.0, 0.0);
	setValues(ListenerOri,0.0, 0.0, -1.0,  0.0, 1.0, 0.0);
	LoadSound(soundfile);	
	SetListenerValues();
}

Sound::~Sound()
{
	KillALData();
}

ALboolean Sound::LoadSound(char* soundfile)
{

	// Variables to load into.

	ALenum format;
	ALsizei size;
	ALvoid* data = NULL;
	ALfloat freq;

	alGenBuffers(1, &Buffer);

	if(alGetError() != AL_NO_ERROR)
		return AL_FALSE;

	data = alutLoadMemoryFromFile((ALbyte*)soundfile, &format, &size, &freq);
	alBufferData(Buffer, format, data, size, freq);
	alGenSources(1, &Source);


	if(alGetError() != AL_NO_ERROR)
		return AL_FALSE;

	alSourcei (Source, AL_BUFFER,   Buffer   );
	alSourcef (Source, AL_PITCH,    1.0      );

	alSourcefv(Source, AL_POSITION, SourcePos);
	alSourcefv(Source, AL_VELOCITY, SourceVel);

	if(alGetError() == AL_NO_ERROR)
		return AL_TRUE;

	return AL_FALSE;
}

void Sound::SetListenerValues()
{
	alListenerfv(AL_POSITION,    ListenerPos);
	alListenerfv(AL_VELOCITY,    ListenerVel);
	alListenerfv(AL_ORIENTATION, ListenerOri);
}

void Sound::KillALData()
{
	alDeleteBuffers(1, &Buffer);
	alDeleteSources(1, &Source);
}

void Sound::Start(bool loop,float volume)
{
	alSourcef (Source, AL_GAIN,volume);
	alSourcei (Source, AL_LOOPING,loop);
	alSourcePlay(Source);
}

void Sound::Stop()
{
	alSourceStop(Source);
}

void Sound::Pause()
{
	alSourcePause(Source);
}

