#include "Menu.hpp"

#include <Graphics/Font.hpp>
#include "Play.hpp"

Play playGame;

/*   MAYBE FOR LATER 
template <class Type>
void GoTo() {
	Type t;	
 	start_screen(&t);
}*/

bool instructions = false;

Menu::Menu() {
	Selection = 0;
	TotalChoices = 1;
}

Menu::~Menu() {
}

void Menu::draw() {
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
	glClear(GL_COLOR_BUFFER_BIT);
	Graphics::FontRef font = Graphics::get_font("gentium.txf");
	assert(font.ref);
	
	if(!instructions)
	{
		glColor3f(0.5f, 0.0f, 0.0f);
		font->draw_center("SOUND BOTS", make_vector(0.0f, 0.4f), 0.3f);

		switch(Selection)
		{
		   case 0: {
				glColor3f(0.0f, 0.0f, 0.5f);
				font->draw_center("Instructions", make_vector(0.0f, -0.2f), 0.2f);
				glColor3f(0.0f, 1.0f, 0.0f);
				font->draw_center("Play Game", make_vector(0.0f, 0.0f), 0.2f);
				break;
			   }

		   case 1: {
				glColor3f(0.0f, 0.0f, 0.5f);
				font->draw_center("Play Game", make_vector(0.0f, 0.0f), 0.2f);
				glColor3f(0.0f, 1.0f, 0.0f);
				font->draw_center("Instructions", make_vector(0.0f, -0.2f), 0.2f);
				break;
			   }
		}

		glColor3f(1.0f, 1.0f, 1.0f);
	   	font->draw_center("UP/DOWN to move  --   ENTER to select  --   ESC to quit", make_vector(0.0f,-1.0f), 0.1f);
	}
	else
	{
		glColor3f(0.5f, 0.0f, 0.0f);
		font->draw_center("INSTRUCTIONS", make_vector(0.0f, 0.4f), 0.3f);

		glColor3f(0.0f, 0.0f, 0.9f);
		font->draw_center("- THERE ARE TWO PLAYERS: GREEN AND RED WHO ARE AGAINST EACH OTHER", make_vector(0.0f, 0.2f), 0.07f);
		glColor3f(0.0f, 1.0f, 0.0f);
		font->draw_center("- PLAYER 1 USES SPACE TO START THE MUSIC AND SPACE TO STOP AND FIRE", make_vector(0.0f, 0.0f), 0.07f);
		glColor3f(1.0f, 0.0f, 0.0f);
		font->draw_center("- PLAYER 2 USES ENTER TO START THE MUSIC AND ENTER TO STOP AND FIRE", make_vector(0.0f, -0.2f), 0.07f);
		glColor3f(0.0f, 0.0f, 0.9f);
		font->draw_center("- FIND THE BALANCE BETWEEN THE SOUND AND YOUR AIM", make_vector(0.0f, -0.4f), 0.07f); 
		glColor3f(0.0f, 0.0f, 0.9f);
		font->draw_center("- EVERY HIT REDUCES YOUR OPPONENT'S SIZE! -> FIRST TO 5 HITS WINS", make_vector(0.0f, -0.6f), 0.07f);
		
		glColor3f(1.0f, 1.0f, 1.0f);
		font->draw_center("ESC to RETURN TO MENU", make_vector(0.0f,-1.0f), 0.1f);
	}
}

void Menu::update() {
	
}

void Menu::handle_event(SDL_Event const &event) {
	if (event.type == SDL_KEYDOWN) {
		if (event.key.keysym.sym == SDLK_UP) {
			if (Selection != 0) {
				Selection--;
			}
		} else if (event.key.keysym.sym == SDLK_DOWN) {
			if (Selection != TotalChoices) {
				Selection++;
			}
		} else if (event.key.keysym.sym == SDLK_RETURN) {
			if(Selection==0)
				start_screen(&playGame);
			else
				instructions = true;

		} else if (event.key.keysym.sym == SDLK_ESCAPE) {
			if(instructions)
				instructions = false;
			else
				quit_screen(this);
		}
	}
}


