
// TODO: enemy kill in triangle, gui display -> (font), code class splitting

#include "Play.hpp"
#include <stdio.h>

char s1[20]  = "";
char s2[20]  = "";
char turnstr[20]  = "";
int turn = -1;
Shooter2D *PlayerA,*PlayerB;
float ang1,ang2;
bool rotatePlayerA,rotatePlayerB,ballSprA,ballSprB;
Sprite *SprA,*SprB,*CircleSprA,*CircleSprB;
Sound *GameSound,*bgSound,*fireSound,*hitSound;
bool changecolorA = false;
bool changecolorB = false;
int P1Score = 0;
int P2Score = 0;
float timerA = 0;
float timerB = 0;
float timerTempA,timerTempB;
float ccTimerA = 0;
float ccTimerB = 0;
bool win = false;
int state = -1;

void rotatePlayer(Shooter2D *,float angle);
void Shoot(Shooter2D *player);
bool checkCollisions(Sprite* sprX,Sprite* sprY);
Uint32 delayedcolorchange(Uint32 interval, void *param);  // an attempt to get SDL_AddTimer to work but it says out of scope ??
Uint32 timerid;

//////////////////////// Play class definitions ///////////////////////////////

Play::Play() {
	PlayerA = new Shooter2D(-1.0,-0.7,0);
	ang1 = 0;
	rotatePlayerA = false;
	ballSprA = false;
	CircleSprA = new Sprite(-1.0,-0.7,0.125);

	PlayerB = new Shooter2D(1.0,-0.7,0);
	ang2 = 0;
	rotatePlayerB = false;
	ballSprB = false;
	CircleSprB = new Sprite(1.0,-0.7,0.125);

	//sounds
	alutInit(0, NULL); // to initialize ALUT

	GameSound = new Sound("sounds/gamesoundnew1.wav");
	bgSound = new Sound("sounds/bgsoundnew.wav");
	fireSound = new Sound("sounds/firesound.wav");
	hitSound = new Sound("sounds/hitsound.wav");
	bgSound->Start(true,0.01);
}

Play::~Play() {
	delete GameSound;
	delete bgSound;
	delete fireSound;
	delete hitSound; 
	delete SprA;
	delete SprB;
	delete CircleSprA;
	delete CircleSprB;
	alutExit();  // to deinitialize alut
}

void Play::draw() {
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
	glClear(GL_COLOR_BUFFER_BIT);

	//draw the base
	glLoadIdentity();
	glColor4f(0,0,0.75,1);
	glBegin(GL_QUADS);
		glVertex2f(-1.5,-1);
		glVertex2f(1.5,-1);
		glVertex2f(1.5,-0.7);
		glVertex2f(-1.5,-0.7);
	glEnd();

	//draw the player shooters
	//PlayerA->Draw(0,1,0,1,"");  // color,type
	//PlayerB->Draw(1,0,0,1,"");

	//draw the player circles
	if(!changecolorA)
	{
		if(PlayerA->getAngle()==0)
			CircleSprA->Draw(0,1,0,0.5,"fill");
		else
			CircleSprA->Draw(0,1,0,1.0,"fill");
	}
	else
		CircleSprA->Draw(1,0,0,0.5,"fill");

	if(!changecolorB)
		if(PlayerB->getAngle()==0)
			CircleSprB->Draw(1,0,0,0.5,"fill");
		else
			CircleSprB->Draw(1,0,0,1.0,"fill");
	else
		CircleSprB->Draw(0,1,0,0.5,"fill");

	//draw the ball which is shot
	if(ballSprA && SprA!=NULL)
		SprA->Draw(0,1,0,1,"fill");

	if(ballSprB && SprB!=NULL)
		SprB->Draw(1,0,0,1,"fill");

	glLoadIdentity();
	glColor3f(1.0f, 0.5f, 1.0f);
	Graphics::FontRef font = Graphics::get_font("gentium.txf");
	font->draw_center(s1, make_vector(-1.0f, 0.65f), 0.1f);
	font->draw_center(s2, make_vector(1.0f, 0.65f), 0.1f);
	glColor3f(0.0f, 1.0f, 0.0f);
	font->draw_center("SPACE", make_vector(-1.0f, -0.95f), 0.07f);	
	glColor3f(1.0f, 0.0f, 0.0f);
	font->draw_center("ENTER", make_vector(1.0f, -0.95f), 0.07f);

	if(!win)
	{
		if(turn==-1)
			glColor3f(0.0f, 1.0f, 0.0f);
		else
			glColor3f(1.0f, 0.0f, 0.0f);
		font->draw_center(turnstr, make_vector(0.0f, 0.45f), 0.15f);
	}
	else
	{
		if(P1Score>P2Score)	
			glColor3f(0.0f, 1.0f, 0.0f);
		else
			glColor3f(1.0f, 0.0f, 0.0f);

		font->draw_center(turnstr, make_vector(0.0f, 0.45f), 0.15f);	
	}
}



void Play::update(float elapsed_time) {

	if(P1Score==5 || P2Score==5)
		win = true;		
		
	if(!win)
	{
		if(turn==-1)
			sprintf(turnstr, "Player A's TURN");
		else
			sprintf(turnstr, "Player B's TURN");
	}
	else
	{
		if(P1Score>P2Score)	
			sprintf(turnstr, "Player A WINS");
		else
			sprintf(turnstr, "Player B WINS");

	}
	sprintf(s1, "P1 : %d", P1Score);
	sprintf(s2, "P2 : %d", P2Score);

	if(rotatePlayerA)
	{
		timerTempA = (SDL_GetTicks() - timerA)/100;
		ang1 = -timerTempA * 3.6; // this is 180/50 since 180 is max angle and 50 is the max length of the sound

		rotatePlayer(PlayerA,ang1);
		if(ang1 < -180)
		{
			rotatePlayerA = false;
			ang1 = 0;
			PlayerA->setAngle(0);
		}
	}
	if(rotatePlayerB)
	{
		timerTempB = (SDL_GetTicks() - timerB)/100;
		ang2 = timerTempB * 3.6; // this is 180/50 since 180 is max angle and 50 is the max length of the sound

		rotatePlayer(PlayerB,ang2);
		if(ang2 > 180)
		{
			rotatePlayerB = false;
			ang2 = 0;
			PlayerB->setAngle(0);
		}
	}

	if(ballSprA)
	{
	    if(SprA!=NULL)
	    {		
		SprA->Update();
			
		if(checkCollisions(SprA,CircleSprB))
		{
			hitSound->Start(false,0.1);
			changecolorB = true;
			ballSprA = false;
			//delete SprA;
			P1Score++;
			ccTimerA = SDL_GetTicks();
			//SprSizeB = SprSizeB - 0.005;
			CircleSprB->setradius(CircleSprB->getradius() - 0.015);
			//SDL_AddTimer(2000, delayedchangecolor, (void *) this);
		}
	     }
	}
	else
	{
		if(ccTimerA!=0 && (SDL_GetTicks() - ccTimerA) > 2000)
		{
			changecolorB = false;
			ccTimerA = 0;
		}
	}

	if(ballSprB)
	{
	      if(SprB!=NULL)
	      {
		SprB->Update();

		if(checkCollisions(SprB,CircleSprA))
		{
			hitSound->Start(false,0.1);
			changecolorA = true;
			ballSprB = false;
			//delete SprB;
			P2Score++;
			ccTimerB = SDL_GetTicks();
			//SprSizeA = SprSizeA - 0.005;
			CircleSprA->setradius(CircleSprA->getradius()-0.015);
		}
	      }
	}
	else
	{
		if(ccTimerB!=0 && (SDL_GetTicks() - ccTimerB) > 2000)
		{
			changecolorA = false;
			ccTimerB = 0;
		}
	}
	
}

// how to get smooth movt
void Play::handle_event(SDL_Event const &event) {
	//Handle events here:
		if (event.type == SDL_KEYDOWN) {
			switch(event.key.keysym.sym)
			{
				case SDLK_ESCAPE: 	{quit_screen(this); break; }
				case SDLK_SPACE: 	{	
							if(state==-1)
							{
								if(!rotatePlayerA)
								{
									if(PlayerA->getAngle()==0)
									{
										GameSound->Start(false,0.1); // loop = false
										timerA = SDL_GetTicks();
									}
										rotatePlayerA = true; 

								}
								else{
									timerA = 0;
									GameSound->Stop();
									fireSound->Start(false,0.1);
									rotatePlayerA = false;
									Shoot(PlayerA); 
									turn = -turn;
									rotatePlayer(PlayerA,0);
									state = -state;
								    }
							}
							break; 
						}
				case SDLK_RETURN: 	{	
							if(state==1)
							{
								if(!rotatePlayerB)
								{
									if(PlayerB->getAngle()==0)
									{
										GameSound->Start(false,0.1);
										timerB = SDL_GetTicks();
									}
									rotatePlayerB = true; 
								}
								else{
									timerB = 0;
									GameSound->Stop();
									fireSound->Start(false,0.1);
									rotatePlayerB = false;
									Shoot(PlayerB);
									turn = -turn; 
									rotatePlayer(PlayerB,0);
									state = -state;
								     }
							}
							break; 
						}
				default: break;
			}
		}
/*
		if (event.type == SDL_MOUSEBUTTONDOWN) {
					float mouse_x = event.motion.x / float(Graphics::screen.x) * Graphics::aspectf() * 2.0f - Graphics::aspectf();
					float mouse_y = event.motion.y / float(Graphics::screen.y) *-2.0f + 1.0f;
					sprintf(s1, "%f", mouse_x);
					sprintf(s2, "%f", mouse_y);
					//ang1++;
					//rotatePlayer(PlayerA,ang1);
		}*/
}

/********************** OTHER FUNCTIONS ******************************/

void rotatePlayer(Shooter2D *player,float ang)
{
	//sprintf(s1, "inside roratplayer");
	player->setAngle(ang);
}

void Shoot(Shooter2D *player)
{
	if(player==PlayerA)
	{	
		//if(SprA!=NULL)
			//delete SprA;
		SprA = new Sprite(PlayerA->get_x(),PlayerA->get_y(),0.025);
		ballSprA = true;
		SprA->xVel = -0.01 * cos(PlayerA->getAngle() * (3.14/180));
		SprA->yVel = -0.012 * sin(PlayerA->getAngle() * (3.14/180));
		SprA->setGravity(true,0.012);
	}	

	if(player==PlayerB)
	{	
		//if(SprB!=NULL)
			//delete SprB;
		SprB = new Sprite(PlayerB->get_x(),PlayerB->get_y(),0.025);
		ballSprB = true;
		SprB->xVel = 0.01 * cos(PlayerB->getAngle() * (3.14/180));
		SprB->yVel = 0.012 * sin(PlayerB->getAngle() * (3.14/180));
		SprB->setGravity(true,0.012);
	}	
}

bool checkCollisions(Sprite* sprX,Sprite* sprY)
{
	float distance = sqrt( pow((sprY->getx()-sprX->getx()),2) + pow((sprY->gety()-sprX->gety()),2) );
	if((sprY->getradius() + sprX->getradius())>distance)
	{
		return true;
	}
	
	return false;
}

/*
Uint32 delayedcolorchange(Uint32 interval, void *param)
{
	changecolor = false;
	return(interval);
}
*/



