/*
 * Sprite.cpp
 *
 *  Created on: Sep 2, 2009
 *      Author: Navin
 */


#include "Sprite.hpp"

using std::vector;

// SDL_WM_SetCaption("Image not loaded ",NULL);


Sprite::Sprite(float x,float y, float r)
{
	xPos = x;
	yPos = y;
	xVel = 0;
	yVel = 0;
	radius = r;
	setGravity(false,0);
}

Sprite::Sprite(std::string imagename,SDL_Surface* Surface,int posX,int posY)
{
	//image = load_image(imagename);
	xPos = posX;
	yPos = posY;
}

Sprite::~Sprite()
{
	SDL_FreeSurface(image);
}

void Sprite::ForcePush(float Fx,float Fy,float maxFx,float maxFy)
{
	if(xVel<maxFx)
		xVel += Fx;
	if(yVel<maxFy)
		yVel += Fy;
}

void Sprite::Draw(float r,float g,float b,float a,std::string type)
{
    glColor4f(r,g,b,a);
    if(type=="empty")
    	drawCircle(xPos,yPos,radius);
    if(type=="fill")
    	drawCircleFill(xPos,yPos,radius);

	//dot->Draw(screen);
/*   -- Future implementations
	Graphics::TextureRef tex = Graphics::get_texture("dot.bmp");
		if (tex.ref) {
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, tex->obj);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
		}


		glBegin(GL_QUADS);
				glTexCoord2f(0.0f, 0.0f); glVertex2f(-0.1f, -0.1f);	// Bottom Left Of The Texture and Quad
				glTexCoord2f(1.0f, 0.0f); glVertex2f( 0.1f, -0.1f);	// Bottom Right Of The Texture and Quad
				glTexCoord2f(1.0f, 1.0f); glVertex2f( 0.1f,  0.1f);	// Top Right Of The Texture and Quad
				glTexCoord2f(0.0f, 1.0f); glVertex2f(-0.1f,  0.1f);	// Top Left Of The Texture and Quad
		glEnd();

		glDisable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, 0);
*/
}


// Why doesnt this work ????
void Sprite::Draw(SDL_Surface* destination)
{
/*	SDL_Rect position;
	position.x = xPos;
	position.y = yPos;
	SDL_BlitSurface( image, NULL, destination, &position );*/
}

// Update the balls movement here
void Sprite::Update()
{
	xPos += xVel;
	yPos += yVel;
	if(onGravity)
	{
		yPos -= 0.5 * gravityVal * gravityTime / 100; // this is assuming all masses are one
		gravityTime++;
	}
}

// courtesy lazyfoo.net tutorials
SDL_Surface* Sprite::load_image( std::string filename )
{
    //The image that's loaded
    SDL_Surface* loadedImage = NULL;

    //The optimized surface that will be used
    SDL_Surface* optimizedImage = NULL;

    //Load the image
    loadedImage = SDL_LoadBMP( filename.c_str() );

    //If the image loaded
    if( loadedImage != NULL )
    {
        //Create an optimized surface
        optimizedImage = SDL_DisplayFormat( loadedImage );

        //Free the old surface
        SDL_FreeSurface( loadedImage );

        //If the surface was optimized
        if( optimizedImage != NULL )
        {
            //Color key surface
            SDL_SetColorKey( optimizedImage, SDL_SRCCOLORKEY, SDL_MapRGB( optimizedImage->format, 0, 0xFF, 0xFF ) );
        }
    }
    else
    {
    	SDL_WM_SetCaption("Image not loaded ",NULL);
    }

    //Return the optimized surface
    return optimizedImage;
}

float Sprite::getx()
{
	return xPos;
}

float Sprite::gety()
{
	return yPos;
}

float Sprite::getradius()
{
	return radius;
}

void Sprite::setradius(float r)
{
	radius = r;
}


void Sprite::setGravity(bool val,float g = 0)
{
	if(val==true)
	{
		onGravity = true;
		gravityVal = g; 
		gravityTime = 0;
	}
	else
		onGravity = false;
}

int Sprite::DetectCollisions(Sprite* lbdot,Sprite* rbdot,Sprite* rtdot,Sprite* ltdot)
{
	if((xPos-0.05)<lbdot->getx())
			return(3);
	if((xPos+0.05)>rbdot->getx())
			return(4);
	if((yPos-0.05)<rbdot->gety())
			return(2);
	if((yPos+0.05)>rtdot->gety())
			return(1);

	return(0);
}

// Lots of scope for some nice AI here!
void Sprite::EnemyAI(float Totalenemies)
{
	Totalenemies++;
	if(	Totalenemies==1)
	{
		xVel = 0.003 + Totalenemies/100;
		yVel = 0.005 - Totalenemies/100;
	}
	else
	{
		xVel = 0.003 + Totalenemies/100;
		yVel = 0.005 - Totalenemies/100;
	}
}


void drawCircle(float x, float y, float radius) {
    float angle;
    glPushMatrix();
    glLoadIdentity();
    glDisable(GL_TEXTURE_2D);
    glLineWidth(1.0f);
    glBegin(GL_LINE_LOOP);
    for(int i = 0; i < 100; i++) {
        angle = i*2*M_PI/100;
        glVertex2f(x + (cos(angle) * radius), y + (sin(angle) * radius));
    }
    glEnd();
    glEnable(GL_TEXTURE_2D);
    glPopMatrix();
}

void drawCircleFill(float x, float y, float radius) {
    float angle;
    glPushMatrix();
    glLoadIdentity();
    glDisable(GL_TEXTURE_2D);
    glLineWidth(1.0f);
    glBegin(GL_TRIANGLE_FAN);
    for(int i = 0; i < 100; i++) {
        angle = i*2*M_PI/100;
        glVertex2f(x + (cos(angle) * radius), y + (sin(angle) * radius));
    }
    glEnd();
    glEnable(GL_TEXTURE_2D);
    glPopMatrix();
}
